package com.bocloud.sms.booter.controller;

import com.bocloud.sms.interfaces.AutoLoginService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.view.RedirectView;

@RestController
@RequestMapping("/v1/autologin")
@Tag(name = "自动登录")
public class AutoLoginController {

    @Autowired
    private AutoLoginService autoLoginService;

    @GetMapping()
    @Operation(summary = "查看API Token")
    public RedirectView autoLogin(
            @RequestHeader(value = "x-forwarded-host", required = false) String host,
            HttpServletRequest request) {
        return autoLoginService.autoLogin(host, request);
    }
}
