package com.bocloud.sms.booter.controller;


import com.bocloud.sms.interfaces.PortalElementPoolService;
import com.megatron.common.model.GeneralResult;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * 组件池controller层
 *
 * @author lyy
 * @version 2.0
 * @time 2017年12月27日
 */
@RestController
@RequestMapping("/v1/portal/elementpools")
@Tag(name = "组件池管理")
public class PortalElementPoolController {
    @Autowired
    private PortalElementPoolService portalElementPoolService;

    /**
     * 组件池列表展示
     *
     * @param module 配置
     * @return 组件池列表
     */
    @Operation(summary = "组件池列表展示")
    @GetMapping
    public GeneralResult list(@RequestParam(value = "module", required = false) String module) {
        return portalElementPoolService.list(module);
    }
}
