package com.bocloud.sms.booter.controller;

import com.bocloud.sms.interfaces.*;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletRequest;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.view.RedirectView;

@RequiredArgsConstructor
@RestController
@RequestMapping("/v1/single/login")
@Tag(name = "单点登录")
public class SingleLoginController {

    @Autowired
    private SingleLoginService service;

    @GetMapping()
    @Operation(summary = "单点登录")
    public RedirectView doLoginCallback(@RequestParam String token, HttpServletRequest request) throws Exception {
        return service.singleLogin(token, request);
    }

}
