package com.bocloud.sms.service;

import com.bocloud.sms.interfaces.AutoLoginService;
import com.bocloud.sms.interfaces.UserService;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.utils.Common;
import com.megatron.framework.utils.IpTool;
import jakarta.servlet.http.HttpServletRequest;
import org.apache.http.util.Asserts;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;
import org.springframework.web.servlet.view.RedirectView;

import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.Map;

@Service
public class AutoLoginServiceImpl implements AutoLoginService {

    @Value("${bocloud.host:}")
    private String configHost;
    @Value("${bocloud.auto-login.enable:false}")
    private Boolean enable;
    @Value("${bocloud.auto-login.username:admin}")
    private String username;
    @Value("${bocloud.auto-login.password:FVaMOvh7+EVC2rl7G5dfTw==}")
    private String password;
    @Value("${bocloud.auto-login.redirect:}")
    private String redirect;

    @Autowired
    private UserService userService;

    @Override
    public RedirectView autoLogin(String headerHost, HttpServletRequest request) {
        if (Boolean.TRUE.equals(enable)) {
            String finalHost = StringUtils.hasText(configHost) ? configHost : "https://" + headerHost + ":60006";

            GeneralResult<Map<String, Object>> loginResult = userService.login(
                    username, password, request.getSession().getId(), IpTool.getIP(request), true
            );
            Asserts.check(loginResult.isSuccess(), loginResult.getMessage());
            String url = finalHost + "/sso?token=" + loginResult.getData().get(Common.TOKEN);
            if (StringUtils.hasText(redirect)) {
                url += "&redirect=" + URLEncoder.encode(redirect, StandardCharsets.UTF_8);
            }
            return new RedirectView(url);
        } else {
            String url = StringUtils.hasText(configHost) ? configHost : "https://" + headerHost + ":60006";
            return new RedirectView(url);
        }
    }

}
