package com.bocloud.sms.service;

import com.bocloud.sms.entity.PortalElementConfig;
import com.bocloud.sms.interfaces.PortalElementConfigService;
import com.bocloud.sms.repository.PortalElementConfigRepository;
import com.megatron.common.model.GeneralResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;


/**
 * @author lyy
 */
@Service
@Slf4j
public class PortalElementConfigServiceImpl implements PortalElementConfigService {
    @Autowired
    private PortalElementConfigRepository portalElementConfigRepository;

    @Override
    public GeneralResult list(Long poolId) {
        try {
            List<PortalElementConfig> configs = this.portalElementConfigRepository.list(poolId);
            return new GeneralResult(true, configs, "查询成功");
        } catch (Exception e) {
            log.error("Query Portal Element Config error:", e);
            return new GeneralResult(false, "查询失败");
        }
    }

}
