package com.bocloud.sms.service.upgrade;

import javax.sql.DataSource;
import java.util.ArrayList;
import java.util.List;

/**
 * 系统升级任务
 * @author luyanchao
 * @date 2021-06-08
 */
public interface UpgradeTask extends Runnable {

    /**
     * 当前任务的名称
     * @return 名称
     */
    String getName();

    /**
     * 当前任务执行进度
     * @return 进度,0-100
     */
    int getPercent();

    /**
     * 当前任务需要在哪些任务执行成功后才能执行
     * @return 当前任务依赖的任务列表
     */
    default List<UpgradeTask> getDependOnTasks() {
        return new ArrayList<>();
    }

    /**
     * 为当前任务指定源数据源
     * @param dataSource 源数据源
     */
    default void setDataSource(DataSource dataSource) {

    }

}
