package com.bocloud.sms.entity;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.*;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 访问限制名单
 *
 * @author wangyu
 * @version 4.2.1-SNAPSHOT
 * @since 2019/11/12
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("admission")
public class Admission extends Generic {

    @PK(PKStrategy.AUTO)
    private Long id;
    /**
     * ip地址
     */
    @Column("ip")
    private String ip;
    /**
     * 访问限制类型
     */
    @Column("type")
    private Type type;
    /**
     * 创建人id
     */
    @Column("creator_id")
    private Long creatorId;
    /**
     * 创建时间
     */
    @Column("gmt_create")
    @IgnoreUpdate
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;
    /**
     * 创建人
     */
    @IgnoreAll
    private String creator;

    public enum Type {
        /**
         * 黑名单
         */
        black,
        /**
         * 白名单
         */
        white,
        /**
         * 无限制
         */
        free
    }
}
