package com.bocloud.sms.entity;

import com.megatron.common.utils.DateDeserializer;
import com.megatron.common.utils.DateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 审计日志归档记录
 *
 * @author zhangdi
 * @since Nov 6,2019
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("log_archive_record")
public class LogArchiveRecord extends Generic {

    /**
     * id
     */
    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * 归档人id
     */
    @Column("user_id")
    private Long userId;
    /**
     * 归档人
     */
    @Column("user_name")
    private String userName;
    /**
     * 归档时间
     */
    @Column("gmt_archive")
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtArchive;
    /**
     * 是否同步删除数据库记录
     */
    @Column("is_deleted")
    private Boolean syncDelete;
    /**
     * 归档结果
     */
    @Column("result")
    private String result;
}