package com.bocloud.sms.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateDeserializer;
import com.megatron.common.utils.DateSerializer;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

/**
 * 用户业务类
 *
 * @author bocloud
 */
@Data
public class UserBean {
    /**
     * id
     */
    private Long id;
    /**
     * 名称
     */
    private String name;
    /**
     * 账号
     */
    private String account;
    /**
     * 密码
     */
    private String password;
    /**
     * 移动电话
     */
    private String mobile;
    /**
     * 邮箱
     */
    private String email;
    /**
     * 微信账号
     */
    private String wechat;
    /**
     * 钉钉账号
     */
    private String dingtalk;
    /**
     * 公司
     */
    private String company;
    /**
     * 所属组织id
     */
    private Long departId;

    /**
     * 组织级联数组
     */
    private List<String> departIds;

    /**
     * 工号
     */
    private String jobNumber;
    /**
     * 租户id
     */
    private Long tenantId;
    /**
     * 描述
     */
    private String remark;
    /**
     * 性别
     */
    private Boolean sex;

    /**
     * 是否是管理员
     */
    private Boolean isManager;
    /**
     * 头像
     */
    private String portrait;
    /**
     * 所属云服务商ID
     */
    private Long serviceAddressId;
    /**
     * 单点登录用户唯一标识
     */
    private String userId;
    /**
     * 有效期
     */
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private Date expiredDate;
}
