package com.bocloud.sms.utils;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Base64;

@Component
@Slf4j
public class WarnUtil {

    @Value("${warn.url:127.0.0.1:1234}")
    private String url;
    @Value("${warn.user:alistar}")
    private String user;
    @Value("${warn.password:alistarapi123}")
    private String password;

    public static void main(String[] args) {
        String user = "alistar:alistarapi123";
        System.out.println(Base64.getEncoder().encodeToString(user.getBytes()));
    }


    public String call(String urlSuffix, String method) throws Exception {
        URL obj = new URL(url + urlSuffix);
        HttpURLConnection connection = (HttpURLConnection) obj.openConnection();

        // 设置请求方法
        connection.setRequestMethod(method);

        // 添加Basic Auth鉴权头
        String auth = user + ":" + password;
        String encodedAuth = Base64.getEncoder().encodeToString(auth.getBytes());
        String authHeaderValue = "Basic " + encodedAuth;
        connection.setRequestProperty("Authorization", authHeaderValue);

        // 发起请求并获取响应码
        int responseCode = connection.getResponseCode();
        log.info("Response Code: " + responseCode);


        // 读取响应数据
        BufferedReader in = new BufferedReader(new InputStreamReader(connection.getInputStream()));
        String inputLine;
        StringBuilder response = new StringBuilder();

        while ((inputLine = in.readLine()) != null) {
            response.append(inputLine);
        }
        in.close();

        // 输出响应
        log.info("Response: " + response.toString());
        return response.toString();

    }
}
