package com.bocloud.sms.utils;

import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.sms.entity.YkReqVo;
import com.bocloud.sms.enums.YkInfo;
import com.google.protobuf.ServiceException;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
@Slf4j
public class YkUtil {

    //参考application.yml配置文件
    @Value("${yk.url:http://36.111.150.83:9527/}")
    private String url;

    @Value("${yk.reqUserId:1}")
    private String reqUserId;

    @Value("${yk.systemId:1}")
    private String systemId;


    public <T>  T call(YkInfo inf, JSONObject params, Class expectCls) throws Exception {
        YkReqVo reqVo = new YkReqVo(reqUserId,systemId,inf.getUrl(),params);
        String str = JSONObject.toJSONString(reqVo);
        log.info("call yk url [{}]" , url);
        log.info("call yk method[{}] req params[{}]",reqVo.getMethod(),str);
        String resultStr = HttpUtil.post(url, str);
        //logger.info("call method[{}] resp params[{}]",reqVo.getMethod(),resultStr);
        JSONObject result = JSONObject.parseObject(resultStr);
        log.info("call yk result [{}]" , result.toString());

        if (result.getInteger("returnCode") != 1) {
            throw new ServiceException("调用运控接口异常" + result.getString("msg"));
        }
        if(JSONObject.class.equals(expectCls)){
            return (T)result.getJSONObject("data");
        }else{
            return (T)result.getString("data");
        }

    }
}
